---
title: Create a new coupon block
slug: campaign/api/create-a-new-coupon-block
docTags: 
createdAt: 2026-09-02T15:04:15.718Z
---

{
  "id": "9tG07vjgds-4sS9lHK7eF",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.campaign.episerver.net/rest/{clientId}/couponblocks",
    "servers": [
      {
        "url": "https://api.campaign.episerver.net/rest/{clientId}/couponblocks"
      }
    ],
    "name": "Create a new coupon block",
    "description": "<p>Create a new coupon block and specify type, internal name and if it should use valid coupon codes.</p>",
    "contentType": "application/x-www-form-urlencoded",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "clientId",
          "type": "integer<int64>",
          "description": "Client ID",
          "format": "int64"
        }
      ],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json",
            "application/vnd.optivo.broadmail.v1+json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [],
      "formDataParameters": [
        {
          "name": "couponSource",
          "kind": "required",
          "type": "string<static | generated | ean13barcode | twooffivebarcode | code128barcode | code128abarcode | code128bbarcode | code128cbarcode>",
          "description": "Coupon source of the coupon block",
          "enum": [
            "static",
            "generated",
            "ean13barcode",
            "twooffivebarcode",
            "code128barcode",
            "code128abarcode",
            "code128bbarcode",
            "code128cbarcode"
          ]
        },
        {
          "name": "useRealCodesForTestMails",
          "kind": "optional",
          "type": "boolean",
          "description": "<p>If true, valid codes for test mails are used</p>"
        },
        {
          "name": "name",
          "kind": "required",
          "type": "string",
          "description": "Internal name of the coupon block"
        }
      ],
      "oAuthParameters": [
        {
          "id": "Authorization",
          "name": "Authorization",
          "kind": "optional",
          "type": "apiKey",
          "in": "header"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "201",
        "description": "The coupon block was created successfully.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "RestCouponBlock",
            "schema": [
              {
                "name": "id",
                "kind": "optional",
                "type": "integer<int64>",
                "description": "Coupon block ID",
                "format": "int64"
              },
              {
                "name": "name",
                "kind": "optional",
                "type": "string",
                "description": "Coupon block name"
              },
              {
                "name": "couponSource",
                "kind": "optional",
                "type": "string",
                "description": "Coupon source of the coupon block"
              },
              {
                "name": "useRealCodesForTestMails",
                "kind": "optional",
                "type": "boolean",
                "description": "<p>If true, valid codes for test mails are used</p>"
              },
              {
                "name": "counter",
                "kind": "optional",
                "type": "object",
                "description": "Counter of coupon codes",
                "modelRef": "#/components/schemas/RestCouponBlockCounter",
                "customType": "RestCouponBlockCounter",
                "schema": [
                  {
                    "name": "codeCount",
                    "kind": "optional",
                    "type": "integer<int64>",
                    "description": "Number of all coupon codes",
                    "format": "int64"
                  },
                  {
                    "name": "assigned",
                    "kind": "optional",
                    "type": "integer<int64>",
                    "description": "Number of all assigned coupon codes",
                    "format": "int64"
                  },
                  {
                    "name": "unassigned",
                    "kind": "optional",
                    "type": "integer<int64>",
                    "description": "Number of all available coupon codes",
                    "format": "int64"
                  }
                ]
              },
              {
                "name": "created",
                "kind": "optional",
                "type": "string<date-time>",
                "description": "Creation date",
                "format": "date-time"
              },
              {
                "name": "modified",
                "kind": "optional",
                "type": "string<date-time>",
                "description": "Modification date",
                "format": "date-time"
              },
              {
                "name": "links",
                "kind": "optional",
                "type": "array",
                "description": "Restful links",
                "example": "",
                "itemType": "object",
                "customType": "object[]",
                "schema": [
                  {
                    "name": "uriBuilder",
                    "kind": "optional",
                    "type": "object",
                    "description": "",
                    "example": "",
                    "schema": []
                  },
                  {
                    "name": "rels",
                    "kind": "optional",
                    "type": "array",
                    "description": "",
                    "example": "",
                    "itemType": "string",
                    "customType": "string[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "rel",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "type",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "params",
                    "kind": "optional",
                    "type": "map",
                    "description": "",
                    "example": "",
                    "customType": "map<string, string>",
                    "schema": []
                  },
                  {
                    "name": "title",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "uri",
                    "kind": "optional",
                    "type": "string<uri>",
                    "description": "",
                    "format": "uri"
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/RestCouponBlock",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "AQnylpkZhvcAY2iUw-mmc",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.campaign.episerver.net/rest/{clientId}/couponblocks \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/x-www-form-urlencoded' \\\n     --data 'couponSource=static' \\\n     --data 'name=string'"
        },
        {
          "id": "YDd7CmIh9THwoIwfUnEzJ",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/x-www-form-urlencoded\");\n\nvar urlencoded = new URLSearchParams();\nurlencoded.append(\"couponSource\", \"static\");\nurlencoded.append(\"name\", \"string\");\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: urlencoded,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.campaign.episerver.net/rest/{clientId}/couponblocks\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "yZ_6zttpGH9WgbjVaOiqT",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.campaign.episerver.net/rest/{clientId}/couponblocks\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/x-www-form-urlencoded\"\nrequest.body = \"couponSource=static&name=string\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "TNb9FvEJG4LGEMHT3KHFV",
          "language": "python",
          "label": "Python",
          "code": "import requests\n\nurl = \"https://api.campaign.episerver.net/rest/{clientId}/couponblocks\"\n\npayload = 'couponSource=static&name=string'\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/x-www-form-urlencoded'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "AQnylpkZhvcAY2iUw-mmc"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-201",
          "language": "201",
          "code": "// The coupon block was created successfully.\n{\n  \"id\": \"\",\n  \"name\": \"\",\n  \"couponSource\": \"\",\n  \"useRealCodesForTestMails\": false,\n  \"counter\": {\n    \"codeCount\": \"\",\n    \"assigned\": \"\",\n    \"unassigned\": \"\"\n  },\n  \"created\": \"\",\n  \"modified\": \"\",\n  \"links\": [\n    {\n      \"uriBuilder\": {},\n      \"rels\": [\n        \"\"\n      ],\n      \"rel\": \"\",\n      \"type\": \"\",\n      \"params\": \"\",\n      \"title\": \"\",\n      \"uri\": \"\"\n    }\n  ]\n}"
        }
      ],
      "selectedLanguageId": "response-0-201"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}